// This file is a part of the Framsticks GDK library.
// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
// Refer to http://www.framsticks.com/ for further information.

#ifndef _PARAMVMOBJ_H_
#define _PARAMVMOBJ_H_

#include "param.h"
#include "extvalue.h"

class ParamVMObj: public DestrBase
{
ParamInterface *iface;
  public:
Param par;
ParamVMObj(ParamInterface *pi=0);
static ExtObject makeObject(ParamInterface *pi);
int findGroupId(const char* name);
#define STATRICKCLASS ParamVMObj
PARAMGETDEF(name) {arg1->setString(iface->getName());}
PARAMGETDEF(props) {arg1->setInt(iface->getPropCount());}
PARAMGETDEF(groups) {arg1->setInt(iface->getGroupCount());}
PARAMPROCDEF(p_make);
PARAMPROCDEF(p_get) {iface->get(arg1->getInt(),*arg2);}
PARAMPROCDEF(p_set) {arg2->setInt(iface->set(arg1[1].getInt(),arg1[0]));}
PARAMPROCDEF(p_getid) {arg2->setString(iface->id(arg1->getInt()));}
PARAMPROCDEF(p_getname) {arg2->setString(iface->name(arg1->getInt()));}
PARAMPROCDEF(p_getgroup)  {arg2->setInt(iface->group(arg1->getInt()));}
PARAMPROCDEF(p_getgrname)  {arg2->setString(iface->grname(arg1->getInt()));}
PARAMPROCDEF(p_gettype) {arg2->setString(iface->type(arg1->getInt()));}
PARAMPROCDEF(p_getflags) {arg2->setInt(iface->flags(arg1->getInt()));}
PARAMPROCDEF(p_gethelp) {arg2->setString(iface->help(arg1->getInt()));}
PARAMPROCDEF(p_findid) {arg2->setInt(iface->findId(arg1->getString()));}
PARAMPROCDEF(p_findgroupid);
PARAMPROCDEF(p_findidingroup);
PARAMPROCDEF(p_setDef) {iface->setDefault((int)arg1->getInt());}
PARAMPROCDEF(p_setAllDef) {iface->setDefault();}
PARAMPROCDEF(p_call);
#undef STATRICKCLASS
};

#endif
